;;
;; export-web-static.scm
;;
;; Generate private member info page.
;;
;; ISC License
;;
;; Copyright 2023 Brmlab, z.s.
;; Dominik Pantůček <dominik.pantucek@trustica.cz>
;;
;; Permission to use, copy, modify, and/or distribute this software
;; for any purpose with or without fee is hereby granted, provided
;; that the above copyright notice and this permission notice appear
;; in all copies.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
;; WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
;; WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
;; AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR
;; CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
;; OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
;; NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
;; CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

(declare (unit export-web-static))

(module
 export-web-static
 (
  gen-html-members
  )

 (import scheme
	 (chicken base)
	 (chicken format)
	 (chicken pathname)
	 brmember
	 util-dir
	 mbase)

 (define (print-html-member mr)
   (print "<html>")
   (print "<head>")
   (print "<title>Brmlab member "
	  (brmember-nick mr)
	  "</title>")
   (print "</head>")
   (print "<body>")
   (print "</body>")
   (print "</html>"))

 (define (gen-html-member mr dir)
   (let ((fname (format "~A.html" (brmember-id mr))))
     (with-output-to-file (make-pathname dir (format "~A.html" (brmember-nick mr)))
       (lambda ()
	 (print-html-member mr)))))

 (define (gen-html-members mb dir)
   (ensure-directory dir)
   (with-mbase-progress%
    mb dir mr
    (gen-html-member mr dir)))

 )
